package org.dromara.elevator.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.SpringUtils;
import org.dromara.common.core.utils.ValidatorUtils;
import org.dromara.common.excel.core.ExcelListener;
import org.dromara.common.excel.core.ExcelResult;
import org.dromara.elevator.domain.bo.EEmployInfoBo;
import org.dromara.elevator.domain.vo.EEmployInfoImportVo;
import org.dromara.elevator.domain.vo.EEmployInfoVo;
import org.dromara.elevator.service.IEEmployInfoService;

import java.util.List;

/**
 * 导入使用单位基础信息
 *
 * @author zy
 */
@Slf4j
public class EEmployInfoImportListener extends AnalysisEventListener<EEmployInfoImportVo> implements ExcelListener<EEmployInfoImportVo> {

    private final IEEmployInfoService employInfoService;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public EEmployInfoImportListener(Boolean isUpdateSupport) {
        this.employInfoService = SpringUtils.getBean(IEEmployInfoService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(EEmployInfoImportVo employVo, AnalysisContext context) {

        EEmployInfoVo employInfo = this.employInfoService.selectByCode(employVo.getCode());
        try {
            // 验证是否存在这个用户
            if (ObjectUtil.isNull(employInfo)) {
                EEmployInfoBo employ = BeanUtil.toBean(employVo, EEmployInfoBo.class);
                ValidatorUtils.validate(employ);
                employInfoService.insertByBo(employ);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、使用单位 ").append(employ.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long elevatorId = employInfo.getId();
                EEmployInfoBo employBo = BeanUtil.toBean(employVo, EEmployInfoBo.class);
                employBo.setId(elevatorId);
                ValidatorUtils.validate(employBo);
                employInfoService.updateByBo(employBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、使用单位 ").append(employVo.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、使用单位 ").append(employVo.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、使用单位 " + employVo.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<EEmployInfoImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<EEmployInfoImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
